import { OnInit, EventEmitter, ElementRef, SimpleChanges } from "@angular/core";
import { ActivatedRoute, Params } from "@angular/router";
import { SalesforceService } from "../../services/salesforce.service";
import { DomSanitizer, SafeHtml } from "@angular/platform-browser";
import { UntypedFormBuilder } from "@angular/forms";
import { DeviceDetectorService } from 'ngx-device-detector';
import { DataService } from '../../services/data.service';
import { ChangeService } from '../../services/change.service';
import { SharedService } from "../../services/shared.service";
import { Question, QuestionBook, AnswerBook, AnswerWrapper, OptionValue, LocalQuestion } from "../../wrapper";
import { I18nService } from "../../i18n.service";
import * as i0 from "@angular/core";
export declare class QuestionnaireComponent implements OnInit {
    private sfService;
    private dataService;
    private changeService;
    private sharedService;
    private route;
    private sanitizer;
    private _formBuilder;
    private deviceService;
    i18nService: I18nService;
    qbId: string;
    insuranceStartDate: string;
    serv: string;
    tkn: string;
    api: string;
    isEdit: boolean;
    handleEvent: EventEmitter<any>;
    handlePage: EventEmitter<any>;
    handleQuestion: EventEmitter<any>;
    handleBook: EventEmitter<any>;
    handleSubmit: EventEmitter<any>;
    params: Params;
    deviceInfo: any;
    abItem: AnswerBook;
    qbItem: QuestionBook;
    questionItem: Question;
    answerWrap: AnswerWrapper;
    radioFlag: boolean;
    dataFlag: boolean;
    dropdownFlag: boolean;
    checkboxFlag: boolean;
    textFlag: boolean;
    taFlag: boolean;
    rtaFlag: boolean;
    dtFlag: boolean;
    timeFlag: boolean;
    dateFlag: boolean;
    fileFlag: boolean;
    emailFlag: boolean;
    numberFlag: boolean;
    alphanumericFlag: boolean;
    bookFlag: boolean;
    listFlag: boolean;
    backButtonFlag: boolean;
    isButtonDisabled: boolean;
    optionValues: OptionValue[];
    subQuestions: Question[];
    inpValue: string;
    answerMap: Map<any, any>;
    dateMap: Map<any, any>;
    selectedhourMap: Map<any, any>;
    selectedminuteMap: Map<any, any>;
    attachmentsMap: Map<any, any>;
    sqOptions: Map<any, any>;
    subAnsMap: Map<any, any>;
    localSubQuestions: LocalQuestion[];
    questionStack: any[];
    questionName: any[];
    attachments: any[];
    attachmentIdList: any[];
    attachmentId: string;
    attachment: any;
    allowedFileExtension: string[];
    fileExceededLimit: boolean;
    fileTypeIncorrect: boolean;
    back: boolean;
    backicon: boolean;
    check: boolean;
    pop: boolean;
    localDate: string;
    currentName: string;
    pathquestion: number;
    percent: number;
    count: number;
    taFocusOut: boolean;
    notValidAccNum: boolean;
    splCCBackClick: boolean;
    summary: any[];
    localSubQMap: Map<any, any>;
    keyIndex: number;
    selDate: any;
    selectDate: string;
    private today;
    private el;
    innerhtml: any;
    possibilities: any;
    innerhtml1: any;
    summaryData: any[];
    hours: any[];
    minutes: string[];
    selectedHour: string;
    selectedMinute: string;
    selectedMeridiem: string;
    valueName: string;
    valueName1: string;
    bookFlagAccept: string[];
    recordId: string;
    currentQuestionId: string;
    spinnerType: string;
    start_date?: any;
    tempoAddress: any[];
    selectedValue: string;
    selectedPostalcode: string;
    selectedProvince: string;
    selectedCity: string;
    selectedArea: string;
    localaddress: any[];
    allAddress: any[];
    PostalCode: string;
    places: any[];
    province: any[];
    progressStyle: string;
    answerCount: number;
    indexCount: number;
    addFlag: boolean;
    myDatePickerOptions: any;
    individualBookButton: boolean;
    allInputValues: any[];
    constructor(sfService: SalesforceService, dataService: DataService, changeService: ChangeService, sharedService: SharedService, route: ActivatedRoute, sanitizer: DomSanitizer, _formBuilder: UntypedFormBuilder, deviceService: DeviceDetectorService, el: ElementRef, i18nService: I18nService);
    onDateChanged(event: any, ques: any): void;
    ngOnInit(): void;
    ngAfterViewInit(): void;
    ngOnChanges(simplechanges: SimpleChanges): void;
    date_TimeMap(): void;
    day(): void;
    change(): void;
    processQB(): void;
    trimLastDummy(input: string): string;
    getProperTime(def: string, input: string): string;
    handleEditClick(value: string): void;
    handleNextClick(): void;
    AnswerSave(): void;
    next(): void;
    getText(value: any): SafeHtml;
    handleBackClick(): void;
    handleBackClickNew(): void;
    private updateAnswerBook;
    private successupdateAB;
    deleteAnswers(answerbook: any): void;
    private successDeleteAB;
    private failureupdateAB;
    private readQuestionBook;
    private successReadBook;
    private failureReadBook;
    private readAnswerbook;
    private successAnswerBookRead;
    private failureAnswerBookRead;
    private readQuestion;
    private successRead;
    trackId(): void;
    private failureRead;
    private saveAnswer;
    htmlDecode(input: any): string;
    private successSave;
    private failureSave;
    private processQuestion;
    setFlag(typ: any): void;
    resetFlag(typ: any): void;
    setOptions(records: any): void;
    childEventCapture(event: any, ques?: any): void;
    handleRichTextChange(value: string): void;
    setSubQuestions(records: any): void;
    optionChange(selValue: any): void;
    clearError(): void;
    clearLocalSubQuesError(quesId: any): void;
    inputValidate(e: any): boolean;
    CCOnChange(inpValue: string): void;
    isNotValidAccNumber(s: string): boolean;
    clearSQError(quesId: any): void;
    uploadFile(event: any, ques?: any): void;
    private successAttachmentCreate;
    private successAttachmentDelete;
    private failureAttachmentCreate;
    private failureAttachmentDelete;
    handleSubmitClick(): void;
    handleCancelClick(): void;
    private createAttachment;
    deleteAttachment(attachmentId: string): void;
    private deleteSFAttachment;
    getFileName(fileNamewithIdandType: any): any;
    fileUI(): void;
    updateProgress(): void;
    townName(area: any): void;
    getTownLocal(): void;
    clearList(): void;
    setSearchListWidth(): void;
    getCode(): void;
    getPostalcode(value: any): void;
    closeDropdown(): void;
    structLocalSubQuestion(ques: LocalQuestion): void;
    addInputBox(question: LocalQuestion, index: number): void;
    removeAddress(quesUniqueId: string, qName: string): void;
    getLocalSubQuestions(id: String): any;
    Add(question: LocalQuestion): void;
    handleLocationSelected(location: any, ques: any): void;
    selectedInput(input: any, ques: any): void;
    handleTextareaValueChange(value: string): void;
    getData(data: any): void;
    displayDate(dateSelected: any, ques: any): void;
    getKey(item: any): any;
    getValue(item: any): any;
    removeCharacters(questionText: string): string;
    static ɵfac: i0.ɵɵFactoryDeclaration<QuestionnaireComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<QuestionnaireComponent, "lib-questionnaire", never, { "qbId": { "alias": "qbId"; "required": false; }; "insuranceStartDate": { "alias": "insuranceStartDate"; "required": false; }; "serv": { "alias": "serv"; "required": false; }; "tkn": { "alias": "tkn"; "required": false; }; "api": { "alias": "api"; "required": false; }; "isEdit": { "alias": "isEdit"; "required": false; }; }, { "handleEvent": "handleEvent"; "handlePage": "handlePage"; "handleQuestion": "handleQuestion"; "handleBook": "handleBook"; "handleSubmit": "handleSubmit"; }, never, never, true, never>;
}
